function getParameterByName(name)
{
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(window.location.search);
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}

var baseDialog=null;
var expertMode=(getParameterByName('mode')=='expert');
var nervDisplay=true;
var nervPopup=true;
Ext.override(Ext.tip.Tip, {
    layout: 'fit'
});

Ext.QuickTips.init();




dss.staticDataModel.initDeviceCacheAsync = function(concurrentFunction) {
	var sResult = dss.ajaxAssyncRequestWithoutAnswer('/json/property/query', {
		'query' : dss.staticDataModel.sQueryStringStructure
	}, function (sResult) {
		var resultObj = Ext.JSON.decode(sResult);
		if (resultObj.ok) {
			if (resultObj.result.zones != null) {
				dss.staticDataModel.nameCache = resultObj.result.zones;
			}
		}
		dss.ajaxAssyncRequestWithoutAnswer('/json/property/query', {
		    'query' : dss.staticDataModel.sQueryStringDevices},
		    function (sResult) {
		    	var resultObj = Ext.JSON.decode(sResult);
		        if (resultObj.ok) {
		            dss.staticDataModel.deviceCache = [];
		            dss.staticDataModel.deviceWithSensorsCache = [];
		            dss.staticDataModel.deviceAKMCache = [];
		            if (resultObj.result.devices!=null) {
		                for ( var iIndex = 0; iIndex < resultObj.result.devices.length; iIndex++) {
		                    var oDevObject = resultObj.result.devices[iIndex];
		                    
		                    var newObject = {
		                        dSID : oDevObject.dSID,
		                        dSUID : oDevObject.dSUID,
		                        name : oDevObject.name,
		                        present : oDevObject.present,
		                        functionID : oDevObject.functionID,
		                        productID : oDevObject.productID,
		                        outputMode : oDevObject.outputMode,
		                        ZoneID : oDevObject.ZoneID,
		                        DSMeterDSID : oDevObject.DSMeterDSID,
		                        DSMeterDSUID : oDevObject.DSMeterDSUID,
		                        HWInfo : oDevObject.HWInfo,
		                        DisplayID: oDevObject.DisplayID,
		                        isVdcDevice: oDevObject.isVdcDevice,
		                        GroupMembership : [],
		                        sensors : [],
		                        specialActions : {}
		                    };
		
		    				var subObject = oDevObject[oDevObject.dSUID];
		    				for (var jIndex = 0; jIndex < subObject.length; jIndex++) {
		    					if (subObject[jIndex].binaryInputs != null) {
		    						newObject.binaryInputs = [];
		    						for (var kIndex = 0; kIndex < subObject[jIndex].binaryInputs.length; kIndex++) {
		    							newObject.binaryInputs.push({
		    								type : subObject[jIndex].binaryInputs[kIndex].inputType,
		    								index : subObject[jIndex].binaryInputs[kIndex].inputIndex
		    							});
		    						}
		    					}
		    					if (subObject[jIndex].sensorEvents != null) {
		    						newObject.sensorEvents = [];
		    						for ( var sKey in subObject[jIndex]) {
		    							if (sKey != 'sensorEvents')
		    								newObject.sensorEvents.push({
		    									name : subObject[jIndex][sKey],
		    									id : sKey
		    								});
		    						}
		    					}
		
		    					if (subObject[jIndex].sensorInputs != null) {
		    						for (var sIndex = 0; sIndex < subObject[jIndex].sensorInputs.length; sIndex++) {
		    							newObject.sensors.push({
		    								type : subObject[jIndex].sensorInputs[sIndex].type
		    							});
		    						}
		    					}
		    					if ((subObject[jIndex].EAN != null) && (dss.staticDataModel.specialAction !== undefined)) {
		    						if (dss.staticDataModel.specialAction[subObject[jIndex].EAN] != null)
		    							newObject.specialActions = dss.staticDataModel.specialAction[subObject[jIndex].EAN];
		    						else if (dss.staticDataModel.specialAction[resultObj.result.devices[iIndex].functionID] != null)
		    							newObject.specialActions = dss.staticDataModel.specialAction[resultObj.result.devices[iIndex].functionID];
		    					}
		
		    					if ((dss.staticDataModel.specialDSIDAction !== undefined) && (dss.staticDataModel.specialDSIDAction[oDevObject.dSUID] != null)) {
		    						if (dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].actions!=null) {
		    							for (var sKeyType in dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].actions) {
		    								if (newObject.specialActions.actions==null)
		    									newObject.specialActions.actions={};
		    								if (newObject.specialActions.actions[sKeyType]==null)
		    									newObject.specialActions.actions[sKeyType]={};
		    								for (var sSubSubKey in dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].actions[sKeyType]) 
		    									newObject.specialActions.actions[sKeyType][sSubSubKey]= dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].actions[sKeyType][sSubSubKey];
		    							}
		    						}
		    						if (dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].triggers!=null) {
		    							for (var sKeyType in dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].triggers) {
		    								if (newObject.specialActions.triggers==null)
		    									newObject.specialActions.triggers= {}
		    								if (newObject.specialActions.triggers[sKeyType]==null)
		    									newObject.specialActions.triggers[sKeyType]={};
		    								newObject.specialActions.triggers[sKeyType]=[];
		    								for (var sSubSubKey in dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].triggers[sKeyType]) 
		    									newObject.specialActions.triggers[sKeyType][sSubSubKey]=dss.staticDataModel.specialDSIDAction[oDevObject.dSUID].triggers[sKeyType][sSubSubKey];
		    							}
		    						}						
		    					}
		    						
		    					
		    					if (subObject[jIndex].button != null) {
		    						if (subObject[jIndex].id != null)
		    							newObject.tasterMode = subObject[jIndex].id;
		    						if (subObject[jIndex].groupMembership != null)
		    							newObject.buttonGroupMembership = subObject[jIndex].groupMembership;
		    						if (subObject[jIndex].activeGroup != null)
		    							newObject.buttonActiveGroup = subObject[jIndex].activeGroup;
		    						if (subObject[jIndex].setsLocalPriority != null)
		    							newObject.buttonSetsLocalPriority = subObject[jIndex].setsLocalPriority;
		    						if (subObject[jIndex].inputMode != null)
		    							newObject.buttonType = subObject[jIndex].inputMode;
		    						if (newObject.buttonActiveGroup == 255)
		    							newObject.buttonActiveGroup = 8;
		    					}
		    					if (subObject[jIndex].groups != null) {
		    						for (var kIndex = 0; kIndex < subObject[jIndex].groups.length; kIndex++) {
		    							newObject.GroupMembership.push(subObject[jIndex].groups[kIndex].id);
		    							if (subObject[jIndex].groups[kIndex].id != 8) // 8
		    																			// kann
		    																			// nicht
		    																			// ausf�hrungsgruppe
		    																			// sein
		    								if (subObject[jIndex].groups[kIndex].id < 16) // nur
		    																				// in
		    																				// den
		    																				// basisgruppen
		    																				// bleiben
		    									newObject.GroupID = subObject[jIndex].groups[kIndex].id; // base
		    																								// color
		    																								// Group
		    						}
		    						if (newObject.GroupID == null)
		    							if (newObject.GroupMembership.length == 1)
		    								newObject.GroupID = newObject.GroupMembership[0];
		    					}
		    				}
		
		    				if (newObject.specialActions.triggers != null)
		    					if (newObject.specialActions.triggers['deviceEvents'] != null) {
		    						if (newObject.sensorEvents == null)
		    							newObject.sensorEvents = [];
		    						for ( var sKey in newObject.specialActions.triggers['deviceEvents']) {
		    							var oObject = newObject.specialActions.triggers['deviceEvents'][sKey];
		    							newObject.sensorEvents.push({
		    								name : oObject.name,
		    								id : oObject.id
		    							});
		    						}
		    					}
		
		    				if (newObject.name == "")
		    					newObject.name = "(" + newObject.DisplayID + ")";
		    				newObject.icon = dss.staticDataModel.getImageForDevice(newObject);
		    				dss.staticDataModel.deviceCache.push(newObject);
		    				if (newObject.sensorEvents != null)
		    					if (newObject.sensorEvents.length > 0)
		    						dss.staticDataModel.deviceWithSensorsCache.push(newObject);
		    				if (newObject.binaryInputs != null)
		    					if (newObject.binaryInputs.length > 0) {
		
		                            if (dss.staticDataModel.hasDeviceStates(newObject.dSUID)) {
		                                if (newObject.buttonType >= 16) {
		                                    dss.staticDataModel.deviceAKMCache.push(newObject);
		                                } else if (newObject.isVdcDevice) {
		                                    dss.staticDataModel.deviceAKMCache.push(newObject);
		                                }
		                            }
		    					}
		    			}
		    		}
		    	}
		    	var zone0Index = -1;
		    	var groupToAdd = [];
		    	for (var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
		    		var oZone = dss.staticDataModel.nameCache[iIndex];
		    		if (oZone.ZoneID === 0) {
		    			zone0Index = iIndex;
		    		}
		    		if (oZone.name == "") {
		    			if (oZone.ZoneID == 0)
		    				oZone.name = _('All rooms');
		    			else
		    				oZone.name = Ext.String.format2(_("Room ID {zone}"), {
		    					zone : oZone.ZoneID
		    				});
		    		}
		    		for (var jIndex = 0; jIndex < oZone.groups.length; jIndex++) {
		    			var oGroup = oZone.groups[jIndex];
		    			oGroup.icon = dss.staticDataModel.getImagePathForGroup(oZone.ZoneID, oGroup.group);
		    			oGroup.name = dss.staticDataModel.getNameForGroup(oZone.ZoneID, oGroup.group);
		    			oGroup.reachable = false;
		    			if (oGroup.group == 0)
		    				oGroup.reachable = true;
		    			if (0 < oGroup.connectedDevices) {
		    				oGroup.reachable = true;
		    				if (-1 === groupToAdd.indexOf(oGroup.group)) {
		    					groupToAdd.push(oGroup.group);
		    				}
		    			}
		    			for (var iDeviceIndex = 0; iDeviceIndex < dss.staticDataModel.deviceCache.length; iDeviceIndex++)
		    				if ((dss.staticDataModel.deviceCache[iDeviceIndex].ZoneID == oZone.ZoneID) || (oZone.ZoneID == 0))
		    					if (dss.staticDataModel.deviceCache[iDeviceIndex].GroupMembership != null)
		    						for (var iDeviceGroupIndex = 0; iDeviceGroupIndex < dss.staticDataModel.deviceCache[iDeviceIndex].GroupMembership.length; iDeviceGroupIndex++)
		    							if (dss.staticDataModel.deviceCache[iDeviceIndex].GroupMembership[iDeviceGroupIndex] == oGroup.group)
		    								oGroup.reachable = true;
		    			dss.staticDataModel.nameCache[iIndex].groups[jIndex] = oGroup;
		    		}
		    	}
		    	if (groupToAdd.length > 0) {
		    		oZone = dss.staticDataModel.nameCache[zone0Index];
		    		for (var jIndex = 0; jIndex < oZone.groups.length; jIndex++) {
		    			var oGroup = oZone.groups[jIndex];
		    			if (-1 !== groupToAdd.indexOf(oGroup.group)) {
		    				oGroup.icon = dss.staticDataModel.getImagePathForGroup(oZone.ZoneID, oGroup.group);
		    				oGroup.name = dss.staticDataModel.getNameForGroup(oZone.ZoneID, oGroup.group);
		    				oGroup.reachable = true;
		    				dss.staticDataModel.nameCache[zone0Index].groups[jIndex] = oGroup;
		    			}
		    		}
		    	}
		
		    	dss.staticDataModel.userGroups = [];
		    	for (var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
		    		if (dss.staticDataModel.nameCache[iIndex].ZoneID == 0) {
		    			for (var jIndex = 0; jIndex < dss.staticDataModel.nameCache[iIndex].groups.length; jIndex++) {
		    				if (dss.staticDataModel.isClusterGroup(dss.staticDataModel.nameCache[iIndex].groups[jIndex].group))
		    					if (dss.staticDataModel.nameCache[iIndex].groups[jIndex].color !== 0) {
		    						dss.staticDataModel.userGroups.push({
		    							id : dss.staticDataModel.nameCache[iIndex].groups[jIndex].group,
		    							name : dss.staticDataModel.nameCache[iIndex].groups[jIndex].name,
		    							reachable : dss.staticDataModel.nameCache[iIndex].groups[jIndex].reachable,
		    							color : dss.staticDataModel.nameCache[iIndex].groups[jIndex].color
		    						});
		    					}
		    			}
		    		}
		    	}
		    	concurrentFunction();
		    }
		);	
	});
};



Ext.define('DSS.addon.Thanos', {

    extend : 'DSS.addon.Framework',

    config : {
        appName : 'Thanos Configurator',
        appId : 'hleedit',
        appVersion : '1.4.5',
        appIcon : 'default_icon.png',
        dSSVersion : '1.9.0'
    },

    getHelp : function() {
        return Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            padding : '0 20 0 0', //top right bottom left
            loader : {
                url : 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                autoLoad : true,
                disableCaching : false
            }
        });
    },
    setOnlineHelp: function (type,values) {
    	
    },
    onlineHelp:null,
    thanosSimulator:null,
    favoriteEditDialog:null,
    preserveSelection:null,
    progress:null,
    moveUp:function() {
    	/* order -1 !!! */
    	var selection=this.grid.getSelectionModel().getSelection();
    	if (selection.length!=1)
    		return;
    	selection=selection[0];
    	this.preserveSelection=selection.get('dSID');
		var baseDSID=selection.get('basedSID');
		var baseOrder=selection.get('order');
		var lastOrder=0;
		var lastDSID=null;
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('thanosStore').getCount();iIndex++) {
			if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('dSID')!=-1)
				if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('basedSID')==baseDSID) {
					if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order')<baseOrder)
						if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order')>lastOrder) {
							lastOrder=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order');
							lastDSID=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('dSID');
						}
				}
		}
		
		this.waitAndReload(this.grid,{
            actions : 'setOrder',
            dsid1 : lastDSID,
            dsid2 : selection.get('dSID')
        });
    },
    moveDown:function() {
    	var selection=this.grid.getSelectionModel().getSelection();
    	if (selection.length!=1)
    		return;
    	selection=selection[0];
    	this.preserveSelection=selection.get('dSID');
		var baseDSID=selection.get('basedSID');
		var baseOrder=selection.get('order');
		var lastOrder=255;
		var lastDSID=null;
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('thanosStore').getCount();iIndex++) {
			if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('dSID')!=-1)
				if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('basedSID')==baseDSID) {
					if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order')>baseOrder)
						if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order')<lastOrder) {
							lastOrder=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order');
							lastDSID=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('dSID');
						}
				}
		}
		this.waitAndReload(this.grid,{
            actions : 'setOrder',
            dsid1 : lastDSID,
            dsid2 : selection.get('dSID')
        });
    },
    getContent : function() {
    	this.progress=Ext.create('Ext.ProgressBar', {
    		   width: 300
    		});

    	this.progress.maximunStep=0;
    	if (Ext.data.StoreManager.lookup('baseDSID') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'baseDSID',
				fields : [ '_id', 'name','modified'],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} 
    	
    	this.thanosSimulator= Ext.create('DSS.addon.ThanosSimulator', {});
    	this.favoriteEditDialog=Ext.create('DSS.component.SettingsEditor',{baseWindow:this});
    	
    	this.onlineHelp= Ext.create('Ext.panel.Panel', {
    		region : 'east',
            border : 1,
            layout : 'fit',
            title : _('Details'),
            collapsible : true,
            collapsed : (window.innerWidth<1300),
            split : true,
            width : 411,
            minWidth : 411,
            margins : '0 0 0 0',
            padding : '0 0 0 0',
            closeAction : 'hide',
            overflowX : 'auto',
            overflowY : 'hidden',
            layout : 'fit',
            items: [this.thanosSimulator]
    	});
    	
        var me=this;
       
       	var screenControlFavoriteMode= Ext.create('DSS.addon.ScreenTypeSelectorFavorite', {});
        var screenControlSceneMode= Ext.create('DSS.addon.ScreenTypeSelectorSceneMode', {});
        var screenControlAppMode= Ext.create('DSS.addon.ScreenTypeSelectorApp',{});
        var nameControl= Ext.create('DSS.addon.ScreenSceneName', {});
        
        var oConfig={
                defaultSortCol:'order',
                grouperField : 'grouping',
                storeConfig: {
                    storeId : 'thanosStore',
                    fields : [ {name:'basedSID', sortType:'asUCText'}, 
                               {name:'dSID', sortType:'asUCText'}, 
                               {name:'grouping',  sortType: 'asUCText' },
                               {name:'type', sortType:'asUCText'}, 
                               {name:'zoneID', sortType:'asUCText'}, 
                               {name:'buttontype', sortType:'asUCText'},
                               {name:'order', sortType:'asUCText'},
                               {name:'buttonTypeConfig'},
                               {name:'keepInSync'},
                               {name:'sceneNames'}, 
                               {name:'favoriteConfig'},
                               {name:'internalScreenNumber'},
                               {name:'buttons'}]
                },
                defaultNewEntryValues:{keepInSync:true},
                multiselect:true,
                columns: [ {
                    header : _('Screentype'),
                    dataIndex : 'type',
                    xtype: 'textcolumn', 
                    flex : 1,
                    customColumnRenderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
                    	if (record.get('type')==-2) 
                    		return '<table><tr><td style="padding-right:5px;"><img src="images/refresh.png" id="dsid_'+record.get('dSID')+'_working" style="width:0px;"><img src="'+dss.staticDataModel.getImagePathForGroup(0,parseInt('' + val,10))+'" id="dsid_'+record.get('dSID')+'_ready"></td><td>' + _('initial readout pending...') + '</td></tr></table>';
                    	else if (record.get('dSID')=='-1')
                    		return '<table><tr><td style="padding-right:5px;"><img src="images/refresh.png" id="dsid_'+record.get('basedSID')+'_favorite_working" style="width:0px;"><img src="/framework/images/deviceIcons/default/star_green.png" id="dsid_'+record.get('basedSID')+'_favorite_ready"></td><td>' + _('Favorites') + '</td></tr></table>';
                    	else
                    		return '<table><tr><td style="padding-right:5px;"><img src="images/refresh.png" id="dsid_'+record.get('dSID')+'_working" style="width:0px;"><img src="'+dss.staticDataModel.getImagePathForGroup(0,parseInt('' + val,10))+'" id="dsid_'+record.get('dSID')+'_ready"></td><td>' + dss.staticDataModel.getNameForGroup(0,parseInt('' + val,10)) + '</td></tr></table>';
                    }
                }, {
                    header : _('Zone'),
                    dataIndex : 'zoneID', 
                    maintainFlex : true,
                    flex : 1,
                    xtype: 'textcolumn',
                    customColumnRenderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
                    	if (record.get('dSID')=='-1')
                        	return '-';
                        return dss.staticDataModel.getNameForZone(parseInt('' + val,10));
                    }
                },{
                    header : _('Pushbutton type'),
                    dataIndex : 'buttontype',
                    xtype:'textcolumn',
                    flex : 1,
                    customColumnRenderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
                    	if (record.get('dSID')=='-1')
                        	return '-';
                    	if (record.get('type')==48)
                        	return '-';
                    	if (record.get('type')==-2)
                        	return '-';
                    	switch (val) {
	                    	case 1:
	                    		return _('area 1 pushbutton (+ scene 2-4)');
	                    	case 2:
	                    		return _('area 2 pushbutton (+ scene 2-4)');
	                    	case 3:
	                    		return _('area 3 pushbutton (+ scene 2-4)');
	                    	case 4:
	                    		return _('area 4 pushbutton (+ scene 2-4)');
	                    	case 5:
	                    		return _('zone pushbutton (+ scene 1-4)');
	                    	case 6:
	                    		return _('zone pushbutton (+ scene 11-14)');
	                    	case 7:
	                    		return _('zone pushbutton (+ scene 21-24)');
	                    	case 8:
	                    		return _('zone pushbutton (+ scene 31-34)');
	                    	case 9:
	                    		return _('zone pushbutton (+ scene 41-44)');
	                    	case 10:
	                    		return _('area 1 pushbutton (+ scene 12-14)');
	                    	case 11:
	                    		return _('area 2 pushbutton (+ scene 22-24)');
	                    	case 12:
	                    		return _('area 3 pushbutton (+ scene 32-34)');
	                    	case 13:
	                    		return _('area 4 pushbutton (+ scene 42-44)');
	                    	case 15:
	                    		return _('Generic (App)');
                    	}
                    	return 'buttonmode' + ' ' + val;
                    }
                },{
                    header : _('dSID'),
                    dataIndex : 'zoneID', 
                    maintainFlex : true,
                    width: 80,
                    xtype: 'textcolumn',
                    customColumnRenderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
                    	if (record.get('dSID')=='-1')
                        	return '-';
                        return record.get('dSID').substr(24,8);
                    }
                
                }],     
                buttonText: {
                    editButton: _('Edit screen'),
                    deleteButton:_('Remove screen')
                },
                customButtons : [ {
    				text : _('Add new scene screen'),
    				iconCls : 'icon-add-action',
    				handler : function () {

                        var parameterSet={keepInSync:true};
                        if (Ext.data.StoreManager.lookup("baseDSID").getCount()==1)
                    	parameterSet.basedSID=Ext.data.StoreManager.lookup("baseDSID").getAt(0).get("_id");
                    	else {
	                    	var selection=me.grid.getSelectionModel().getSelection();
	                    	if (selection.length==1) {
	                    		parameterSet.basedSID=selection[0].get('basedSID');
	                    	}
	                    }
                        
    					me.grid.editorWindow.editControls.basedSID.cboCombo.setReadOnly(false);
                        me.grid.getSelectionModel().deselectAll();
                        me.grid.editorWindow.setTitle(_('Add new scene screen'));
                        me.grid.editorWindow.editControls.favoriteConfig.setVisible(false);
            			me.grid.editorWindow.editControls.buttonTypeConfig.setVisible(true);
            			me.grid.editorWindow.editControls.buttonTypeConfig.setDisabled(false);
            			me.grid.editorWindow.editControls.buttons.setVisible(false);
            			me.grid.editorWindow.editControls.sceneNames.setVisible(true);
            			me.grid.editorWindow.editControls.keepInSync.setVisible(true);
            			me.grid.editorWindow.editControls.keepInSync.setValue(true);
            			me.grid.editorWindow.setHeight(450);

                        me.grid.editorWindow.show();
                        me.grid.editorWindow.setValues(parameterSet);
    				}
                },{
    				text : _('Add new generic screen'),
    				iconCls : 'icon-add-action',
    				handler : function () {

                        var parameterSet={keepInSync:true};
                        if (Ext.data.StoreManager.lookup("baseDSID").getCount()==1) {
                        	parameterSet.basedSID=Ext.data.StoreManager.lookup("baseDSID").getAt(0).get("_id");
                        } else {
	                    	var selection=me.grid.getSelectionModel().getSelection();
	                    	if (selection.length==1) {
	                    		parameterSet.basedSID=selection[0].get('basedSID');
	                    	}
	                    }

    					me.grid.editorWindow.editControls.basedSID.cboCombo.setReadOnly(false);
                        me.grid.getSelectionModel().deselectAll();
                        me.grid.editorWindow.setTitle(_('Add new generic screen'));
                        me.grid.editorWindow.editControls.favoriteConfig.setVisible(false);
                        me.grid.editorWindow.editControls.buttonTypeConfig.setVisible(false);
            			me.grid.editorWindow.editControls.buttonTypeConfig.setDisabled(false);
            			me.grid.editorWindow.editControls.buttons.setVisible(true);
            			me.grid.editorWindow.editControls.sceneNames.setVisible(false);
            			me.grid.editorWindow.editControls.keepInSync.setVisible(false);
            			me.grid.editorWindow.setHeight(540);

                        me.grid.editorWindow.show();
                        me.grid.editorWindow.setValues(parameterSet);
    				}
                },{
    				text : _('Edit general settings'),
    				iconCls : 'icon-edit-action',
    				handler : function () {
    					me.favoriteEditDialog.baseWindow=me;
    					me.favoriteEditDialog.show();    			    	
    				}
                },{
    				text : _('Start configuration wizard'),
    				iconCls : 'icon-edit-action',
    				handler : function () {
    					me.startWizard();
    				}
                }],
                customButtonsRAlign: [{
    				text : '',
    				iconCls : 'scrollButtonUp',
    				handler : function () {
    					me.moveUp();
    				}
                },{
    				text : '',
    				iconCls : 'scrollButtonDown',
    				handler : function () {
    					me.moveDown();
    				}
                }],
                editorConfig:{
                    title : _('Edit screen'),
                    staticControls : [ {
                        type : 'hidden',
                        label : _('id'),
                        id : 'dSID'
                    }, {
                        type : 'combobox',
                        label : _('Device'),
                        id : 'basedSID',
                        allowBlank:false,
                        storevalueid:'_id',
                        storedisplayid:'name',
                        storeid:'baseDSID'
                    }, {
                    	type : 'custom',
                    	id: 'buttonTypeConfig',
                    	control : screenControlSceneMode
                    }, {
                    	type: 'custom',
                    	id: 'sceneNames',
                    	control : nameControl 
                    }, {
                    	type:'custom',
                    	id:'buttons',
                    	control : screenControlAppMode
                    }, {
                    	type:'checkbox',
                    	id:'keepInSync',
                    	//title:'&nbsp;',
                    	label:_('keep button names in sync with scene names')
                    }, {
                    	type : 'custom',
                    	id: 'favoriteConfig',
                    	control : screenControlFavoriteMode
                    }, {
                    	type:'hidden',
                    	id:'internalScreenNumber',
                    	label:'_'
                    }]
                },
                listeners: {
                	'selectionChanged':function (grid,values) {
                		me.grid.editorWindow.setTitle(_('Edit screen'));
                		me.grid.btnCustom[2].setDisabled(true);
                		me.setOnlineHelp('gridSelection',values);
                		if (values.length==0) {
                			me.grid.btnEdit.setDisabled(true);
                			me.grid.btnDelete.setDisabled(true);
                			me.grid.btnCustom[0].setDisabled(!me.fSomethingAvaible);
                			me.grid.btnCustom[1].setDisabled(!me.fSomethingAvaible);
                			me.grid.btnCustom[2].setDisabled(true);
                		}
                		if (values.length==1) {
                    		var baseDSID=values[0].get('basedSID');
                    		var iActiveElements=0;
                    		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup("thanosStore").getCount();iIndex++) {
                    			if (Ext.data.StoreManager.lookup("thanosStore").getAt(iIndex).get('basedSID'))
                    				iActiveElements++;
                    		}
                    		var fPreviewState=false;
                    		var recordSetting=Ext.data.StoreManager.lookup('generalSetting').findRecord('dsid',baseDSID,0,true,false,true);
                    		if (recordSetting!=null) {
                    			var oValue=recordSetting.get('values');
                				for (var iIndex=0;iIndex<oValue.length;iIndex++)
                					if (oValue[iIndex].deviceIndex==0)
                    					if (oValue[iIndex].bank==127)
                        					if (oValue[iIndex].index==50)
                        						fPreviewState=(oValue[iIndex].value&0x80)>0;
                    		}
                    		me.grid.editorWindow.editControls.basedSID.cboCombo.setReadOnly(true);
                    		if (values[0].get('type')==-2) {
                    			me.grid.btnEdit.setDisabled(true);
                    			me.grid.btnDelete.setDisabled(true);
                    			me.grid.btnCustom[2].setDisabled(true);
                    			me.grid.btnCustomRAlign[0].setDisabled(true);
                    			me.grid.btnCustomRAlign[1].setDisabled(true);
                    			me.grid.btnCustomRAlign[2].setDisabled(true);
                    		} else {                    		
	                			me.grid.btnCustom[2].setDisabled(false);
	                			me.favoriteEditDialog.setDSID(values[0].get('basedSID'));
	                    		if (values[0].get('dSID')=='-1') {
	                        		me.grid.editorWindow.setTitle(_('edit favorite'));
	                    			me.grid.btnCustomRAlign[0].setDisabled(true);
	                    			me.grid.btnCustomRAlign[1].setDisabled(true);
	                    			me.grid.editorWindow.editControls.favoriteConfig.setVisible(true);
	                    			me.grid.editorWindow.editControls.keepInSync.setVisible(false);
	                    			me.grid.editorWindow.editControls.sceneNames.setVisible(false);
	                    			me.grid.editorWindow.editControls.buttonTypeConfig.setVisible(false);
	                    			me.grid.editorWindow.editControls.buttons.setVisible(false);
	                    			me.grid.editorWindow.setHeight(400);
	                    			me.thanosSimulator.setFavorite(values[0].get('favoriteConfig'),fPreviewState);
	                    			me.grid.btnDelete.setDisabled(true);
	                    		} else {
	                    			var baseDSID=values[0].get('basedSID');
	                    			var maxOrder=0;
	                    			var minOrder=255;
	                    			for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('thanosStore').getCount();iIndex++) {
	                    				if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('basedSID')==baseDSID) {
	                    					
	                    					if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order')<minOrder)
	                    						if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order')!=0){
	                    							if ((expertMode) || (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('internalScreenNumber')>2))                    								
	                    								minOrder=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order');
	                    						}
	                            					
	                    					
	                    					if (Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order')>maxOrder)
	                    						maxOrder=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex).get('order');
	                    				}
	                    			}
	                    			me.grid.btnCustomRAlign[0].setDisabled((values[0].get('order')==minOrder));
	                    			me.grid.btnCustomRAlign[1].setDisabled((values[0].get('order')==maxOrder));
	                    			me.grid.editorWindow.editControls.buttonTypeConfig.setDisabled(false);
	                    			if (!expertMode) {
	                    				
	                    				if (values[0].get('internalScreenNumber')<3) {
	                            			me.grid.btnCustomRAlign[0].setDisabled(true);
	                            			me.grid.btnCustomRAlign[1].setDisabled(true);
	                            			me.grid.btnDelete.setDisabled(true);
	                            			me.grid.editorWindow.editControls.buttonTypeConfig.setDisabled(true);
	                    				} 
	                    				if (values[0].get('internalScreenNumber')==2) {
	                            			me.grid.btnEdit.setDisabled(true);
	                    				}
	                    			}
	                    			me.grid.editorWindow.editControls.favoriteConfig.setVisible(false);
	                    			if (values[0].get('type')==8) {
	                        			me.grid.editorWindow.editControls.buttonTypeConfig.setVisible(false);
	                        			me.grid.editorWindow.editControls.buttons.setVisible(true);
	                        			me.grid.editorWindow.editControls.sceneNames.setVisible(false);
	                        			me.grid.editorWindow.editControls.keepInSync.setVisible(false);
	                        			me.grid.editorWindow.setHeight(540);
	                    			} else {
	                        			me.grid.editorWindow.editControls.buttonTypeConfig.setVisible(true);
	                        			me.grid.editorWindow.editControls.buttons.setVisible(false);
	                        			me.grid.editorWindow.editControls.sceneNames.setVisible(true);
	                        			me.grid.editorWindow.editControls.keepInSync.setVisible(true);
	                        			me.grid.editorWindow.setHeight(450);
	                    			}
	                    				
	                    			me.thanosSimulator.setType(values[0].get('type'),values[0].get('sceneNames'),fPreviewState);
	                    		}
                    		}
                    		if (iActiveElements>8) {
                    			me.grid.btnCustom[1].setDisabled(true);
                    			me.grid.btnCustom[0].setDisabled(true);
                    		} else {
                    			me.grid.btnCustom[1].setDisabled(false);
                    			me.grid.btnCustom[0].setDisabled(false);
                    		} 
                    	} else {
                    		me.thanosSimulator.resetSimulator();
                    	}                		                		
                	},
                    'loadDataStore':function (grid){
                        me.loadParameter(grid);
                    },
                    'saveEntry':function (grid,values){ 
                    	 me.waitAndReload(grid,{
                             actions : 'setScreen',
                             value : Ext.JSON.encode(values)
                         });
                    },
                    'deleteEntry':function (grid,entry){ 
                     	var idVal;
                    	if (entry.get!=null) {
                    		idVal=[entry.get('dSID')];
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('dSID'));
                    	}
                        me.waitAndReload(grid,{
                            actions : 'removeScreen',
                            id : Ext.JSON.encode(idVal)
                        });
                       
                    },
                    'testEntry':function (grid,entry){
                    }
                }
        };
        this.grid=Ext.create('DSS.gridPanel', oConfig);
        this.grid.statusBar.items.insert(0,this.progress);
        this.progress.setVisible(false);
        this.progress.maximunStep=0;
		this.fShouldWork=false;      
		
		this.grid.btnCustom[0].setDisabled(true);
		this.grid.btnCustom[1].setDisabled(true);
		this.grid.btnCustom[2].setDisabled(true);
        
		this.grid.btnCustomRAlign[0].setTooltip(_("Move screen icon left on thanos."));
		this.grid.btnCustomRAlign[1].setTooltip(_("Move screen icon right on thanos."));

        this.startQueue();
        window.setTimeout("globalCheck();",5*1000);
        baseDialog=this;
        return Ext.create('Ext.panel.Panel', {
        	layout : {
                type : 'border'
            },
            border: false,
        	items: [{
        	        	xtype:'panel',
			            region : 'center',
			            border : false,
			            layout:'fit',
			            items : [this.grid]
        	        },this.onlineHelp]
        }); 
    },
    wizardDialog:null,
    showEmptyNotice: function () {
    	if (!nervPopup)
    		return;
    	var myWindow=Ext.create('Ext.window.Window', {
    	    height: 200,
    	    width: 400,
    	    layout: 'fit',
    	    closeAction: 'hide',
    	    modal:true,
    	    resizable:true,
    	    items: { 
                xtype : 'panel',
                html : _('This app is designed for configurating Thanos devices. To use this app please install a Thanos device. If you have a Thanos device freshly installed, a datacopy of the configuration for this devices will be readout. '+ 
                		'The readout of the configuration data of a Thanos will take a while, up to 30 minutes are common.'),
                bodyPadding : 5,
                border : 0,
                dockedItems: [{
                    xtype: 'toolbar',
                    dock: 'bottom',
                    ui: 'footer',
                    defaults: {minWidth: 75},
                    items: ['->',{
                    	xtype:'button',
                    	text : _('OK'),
    	                handler : function() {    	                	
    	                	myWindow.hide();
    	                }
                    }]
                }]
            }    		
    	});
    	myWindow.show();
    	nervPopup=false;
    },
    startWizard: function() {
    	var me=this;
    	if (this.wizardDialog!=null) {
    		return;
    	}

        var DeviceRoomSelector= Ext.create('DSS.wizard.DeviceRoomSelector',{});
        var ScreenAssitentSelector= Ext.create('DSS.wizard.ScreenAssitentSelector',{});
        var AssistentFavoriteSelector= Ext.create('DSS.wizard.FavoriteAssitentSelector', {});

    	this.wizardDialog=Ext.create('DSS.component.Wizard', {
			height:400,
			width:750,
			title:_('Thanos configuration wizard'),
			pages:[{
				shortTitle:_('Select device'),
				longTitle:_('Assistent - Step 1 - Device selection'),
				longDescription: _('Select a thanos and the main zone for that device'),
				controls:[{
					id:'baseValues',
					type:'custom',
					control:DeviceRoomSelector
				}]
			},{
				shortTitle:_('Screens'),
				longTitle:_('Assistent - Step 2 - Screen selection'),
				longDescription: _('Choose which screens should be set and if existings screens should be retained'),
				controls:[{
					id:'screenValues',
					type:'custom',
					control:ScreenAssitentSelector
				}],
				constrainFunc: function (id,values) {
					if (values!=null)
						if (values.baseValues!=null)
							return true;
					return false;
				}
			},{
				shortTitle:_('Favorites'),
				longTitle:_('Assistent - Step 3 - Favorites'),
				longDescription: _('Finally choose some favorite'),
				controls:[{
					id:'favorites',
					type:'custom',
					control:AssistentFavoriteSelector
				}],
				constrainFunc: function (id,values) {
					if (values!=null)
						if (values.baseValues!=null)
							if (values.screenValues!=null)
								return true;
					return false;
				}
			}],
			startLongTitle:_('Thanos configuration wizard - longer title'),
			hideLeftFinish:true,
			startDescription:_('This wizard will help you for easy defining the thanos configuration'),
			finishFunc: function (values) {
				me.wizardDialog=null;
				var baseDSID=values.baseValues.baseDSID;
				var removeScreens=[];
				for (var sKey in values.screenValues.targetStructure) {
					if (values.screenValues.targetStructure[sKey].type==-1) {
						removeScreens.push(values.screenValues.targetStructure[sKey].dSID);
					} else {
						if (values.screenValues.targetStructure[sKey].shouldMaintained!=null)
							if (values.screenValues.targetStructure[sKey].shouldMaintained!=true) {
								//setScreen
								var parameterObject={
									dSID:sKey,
									basedSID:values.screenValues.targetStructure[sKey].basedSID,
									keepInSync:true,
									sceneNames:values.screenValues.targetStructure[sKey].sceneNames,
									buttonTypeConfig: {
										zone:values.screenValues.targetStructure[sKey].zoneID,
										group:values.screenValues.targetStructure[sKey].type,
										button:5
									}
								};
								dss.raiseEvent('thanos.config',{actions : 'setScreen',value : Ext.JSON.encode(parameterObject)});
							}
					}
					dss.raiseEvent('thanos.config',{actions:'setOrderDirectly',dsid:sKey,order:values.screenValues.targetStructure[sKey].order,noStore:'false'});
					// favorites
				}
				dss.raiseEvent('thanos.config',{actions:'removeScreen',id:Ext.JSON.encode(removeScreens)});

				var parameterObject={
						dSID:-1,
						basedSID:baseDSID,
						keepInSync:true,
						favoriteConfig:values.favorites
					};
				
				dss.raiseEvent('thanos.config',{actions : 'setScreen',
                     value : Ext.JSON.encode(parameterObject)});
				me.fShouldWork=true;
				me.progress.setVisible(true);
				me.progress.maximunStep=0;
				me.grid.setStatus(_('Preparing data'));
			}
		});
		this.wizardDialog.addListener("hide",function () {
			me.wizardDialog=null;
		});
    	if (this.grid==null) {
    		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('baseDSID').count();iIndex++) {
    			if (Ext.data.StoreManager.lookup('baseDSID').getAt(iIndex).get('modified')==false) {
    	    		var oStartValue={};
    	    		oStartValue.baseValues={};
    	    		oStartValue.baseValues.baseDSID=Ext.data.StoreManager.lookup('baseDSID').getAt(iIndex).get('_id');
    	    		this.wizardDialog.startWizard(oStartValue);
    				return;
    			}
    		}
    	} else {
	    	var oSelection=this.grid.getSelectionModel().getSelection();
	    	if (oSelection.length==1) {
	    		var oStartValue={};
	    		oStartValue.baseValues={};
	    		oStartValue.baseValues.baseDSID=oSelection[0].get('basedSID');
	    		this.wizardDialog.startWizard(oStartValue);
	    	} else
	    		this.wizardDialog.startWizard();
    	}
    },
    loadParameter : function(grid) {
    	var fWizardShouldBeHinted=false;
    	var oArray=[];
    	this.fSomethingAvaible=false;
    	grid.btnCustom[2].setDisabled(true);
    	var me=this;
    	//dss.staticDataModel.initCaches();
    	dss.staticDataModel.initDeviceCacheAsync(
    		function () {
    			var sSRString = dss.ajaxAssyncRequestWithoutAnswer('/json/property/query2', {
    				'query' : '/scripts/system-addon-scene-responder/entries/*(id)/actions/*(*)'
    			}, function (sSRString) {
        			var SRresult = Ext.JSON.decode(sSRString);
        	    	dss.ajaxAssyncRequestWithoutAnswer('/json/property/query2', {
        				'query' : '/scripts/thanos/devices/*(id,modified)/*(*)/*(*)/*(*)/*(*)'
        			}, function (sString) {
            			var result = Ext.JSON.decode(sString);
            			if (Ext.data.StoreManager.lookup('baseDSID') == null) {
            				Ext.create('Ext.data.Store', {
            					storeId : 'baseDSID',
            					fields : [ '_id', 'name'],
            					proxy : {
            						type : 'memory',
            						reader : {
            							type : 'json',
            							root : 'items'
            						}
            					}
            				});
            			}
            	    	
            			
            	       	if (Ext.data.StoreManager.lookup('generalSetting') == null) {
            				Ext.create('Ext.data.Store', {
            					storeId : 'generalSetting',
            					fields : [ 'dsid', 'values'],
            					proxy : {
            						type : 'memory',
            						reader : {
            							type : 'json',
            							root : 'items'
            						}
            					}
            				});
            			} else {
            				Ext.data.StoreManager.lookup('generalSetting').removeAll();
            			}

            	    	

            			
            			Ext.data.StoreManager.lookup('baseDSID').removeAll();
            	       	for (var sKey in result.result) {
            				var present=false;
            				var unready=false;
            				if (dss.staticDataModel.getDevice(sKey).present!=null)
            					if (dss.staticDataModel.getDevice(sKey).present==true)
            						present=true;
            				
            	    		for (var iIndex=0;iIndex<8;iIndex++) {
            	    			var resultResult=result.result[sKey][""+iIndex];
            	    			if (resultResult==null)
            	    				unready=true;
            	    			else
            		    			if (resultResult.buttonType==null)
            		    				unready=true;
            	    		}
            				
            				if (present) {
            		    		var baseDSID=sKey;
            		    		var oDeviceObject=dss.staticDataModel.getDevice(baseDSID);
            		    		var generalObject=[];
            		    		var fShowFavorite=true;
            		    		var fDeviceHasBeenConfigured=false;
            		    		if (!unready) {	    		
            		    			
            		    			if (result.result[sKey].modified!=null)
            	    	    			fDeviceHasBeenConfigured=true;
            	    	    		else
            	    	    			fWizardShouldBeHinted=true;
            		    			
            			    		Ext.data.StoreManager.lookup('baseDSID').add({_id:baseDSID,name: oDeviceObject.name + ' ('  +  baseDSID.substr(24,8) + ')','modified':(result.result[sKey].modified!=null)});		
            			    		
            			    		for (var gKey in result.result[sKey].generalSettings) {
            			    			generalObject.push({
            			    				deviceIndex:result.result[sKey].generalSettings[gKey].deviceIndex,
            			    				bank:result.result[sKey].generalSettings[gKey].bank,
            			    				index:result.result[sKey].generalSettings[gKey].index,
            			    				value:result.result[sKey].generalSettings[gKey].value
            			    			});
            			    			
            			    			if (result.result[sKey].generalSettings[gKey].deviceIndex==0)
            			    				if (result.result[sKey].generalSettings[gKey].bank==127)
            			    					if (result.result[sKey].generalSettings[gKey].index==50)
            			    						fShowFavorite=(result.result[sKey].generalSettings[gKey].value&0x04)>0;
            			    		}
            			    		Ext.data.StoreManager.lookup('generalSetting').add({
            			    			dsid:baseDSID,
            			    			values:generalObject
            			    		});
            		    		} else {
            		    			fShowFavorite=false;
            		    		}

            		    		baseIndex=parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16);
            		
            		    		parentDSID=baseDSID.substring(0,baseDSID.length-3);
            		    		var screenTypeMapping={};
            		    		
            		    		for (var iIndex=0;iIndex<8;iIndex++) {
            		    			var fScreenAvaible=false;
            		    			var resultResult=result.result[sKey][""+iIndex];
            		    			dSID=parentDSID + '' + (baseIndex+iIndex).toString(16) + "00";
            		        		var oDeviceSubObject=dss.staticDataModel.getDevice(dSID);
            		        		
            		        		if (!unready) {
            		    	    		

            		        			
            			        		var oObject={
            			        				dSID:dSID,
            			        				grouping: oDeviceObject.name + ' ('  +  baseDSID.substr(24,8) + ')',
            			        				basedSID:baseDSID,
            			        				type:resultResult.screenType,
            			        				zoneID:oDeviceSubObject.ZoneID,
            			        				buttontype:resultResult.buttonType,
            			        				internalScreenNumber:(iIndex+1),
            			        				order:resultResult.order,
            			        				buttonTypeConfig:{
            			        					group:resultResult.screenType,
            			        					button:resultResult.buttonType,
            			        					zone:oDeviceSubObject.ZoneID
            			        				},
            			        				sceneNames:{
            			        					scene1:dss.unescapeProperty(resultResult.buttonName1),
            			        					scene2:dss.unescapeProperty(resultResult.buttonName5),
            			        					scene3:dss.unescapeProperty(resultResult.buttonName7),
            			        					scene4:dss.unescapeProperty(resultResult.buttonName9)
            			        				},
            			        				keepInSync:true,
            			        				favoriteConfig:null,
            			        				buttons:{
            			        					button1:{name:dss.unescapeProperty(resultResult.buttonName1),actions:null},
            			        					button2:{name:dss.unescapeProperty(resultResult.buttonName5),actions:null},
            			        					button3:{name:dss.unescapeProperty(resultResult.buttonName7),actions:null},
            			        					button4:{name:dss.unescapeProperty(resultResult.buttonName9),actions:null}
            			        				}
            			        			};
            			        		
            			        		screenTypeMapping[''+(iIndex+1)]=resultResult.screenType;
            			        		
            			        		if (SRresult.result!=null)
            			        			if (SRresult.result['thanos' + dSID + '.0']) {
            			        				oObject.buttons.button1.actions=[];
            			        				for (var subKey in SRresult.result['thanos' + dSID + '.0'])
            			        					if (subKey!='id')
            			        						oObject.buttons.button1.actions.push(SRresult.result['thanos' + dSID + '.0'][subKey]);
            			        			}
            			        		if (SRresult.result!=null)
            			        			if (SRresult.result['thanos' + dSID + '.1']) {
            			        				oObject.buttons.button2.actions=[];
            			        				for (var subKey in SRresult.result['thanos' + dSID + '.1'])
            			        					if (subKey!='id')
            			        						oObject.buttons.button2.actions.push(SRresult.result['thanos' + dSID + '.1'][subKey]);
            			        			}
            			        		if (SRresult.result!=null)
            			        			if (SRresult.result['thanos' + dSID + '.2']) {
            			        				oObject.buttons.button3.actions=[];
            			        				for (var subKey in SRresult.result['thanos' + dSID + '.2'])
            			        					if (subKey!='id')
            			        						oObject.buttons.button3.actions.push(SRresult.result['thanos' + dSID + '.2'][subKey]);
            			        			}
            			        		if (SRresult.result!=null)
            			        			if (SRresult.result['thanos' + dSID + '.3']) {
            			        				oObject.buttons.button4.actions=[];
            			        				for (var subKey in SRresult.result['thanos' + dSID + '.3'])
            			        					if (subKey!='id')
            			        						oObject.buttons.button4.actions.push(SRresult.result['thanos' + dSID + '.3'][subKey]);
            			        			}

            			        		if (resultResult.keepInSync!=null)
            			        			oObject.keepInSync=resultResult.keepInSync;
            			        		
            			        		if (dss.staticDataModel.getDevice(dSID).present!=null)
            			    				if (dss.staticDataModel.getDevice(dSID).present==true)
            					        		if (resultResult.screenType!=0) {
            					        			oArray.push(oObject);
            					        			fScreenAvaible=true;
            					        		}
            			        		if (!fScreenAvaible)
            			        			me.fSomethingAvaible=true;
            		        		} else {
            		        			var oObject={
            			        				dSID:dSID,
            			        				grouping: oDeviceObject.name + ' ('  +  baseDSID.substr(24,8) + ')',
            			        				basedSID:baseDSID,
            			        				type:-2,
            			        				zoneID:oDeviceSubObject.ZoneID,
            			        				buttontype:-1,
            			        				internalScreenNumber:(iIndex+1),
            			        				order:iIndex,
            			        				buttonTypeConfig:null,
            			        				sceneNames:{
            			        					scene1:"",
            			        					scene2:"",
            			        					scene3:"",
            			        					scene4:""
            			        				},
            			        				keepInSync:true,
            			        				favoriteConfig:null,
            			        				buttons:{
            			        					button1:{name:"",actions:null},
            			        					button2:{name:"",actions:null},
            			        					button3:{name:"",actions:null},
            			        					button4:{name:"",actions:null}
            			        				}
            			        			};
            			        		
            			        		screenTypeMapping[''+(iIndex+1)]=-1;
            			        		
            			        		if (dss.staticDataModel.getDevice(dSID).present!=null)
            			    				if (dss.staticDataModel.getDevice(dSID).present==true)
            			    					oArray.push(oObject);    	
            		        		}
            		    		}	    		
            		    		
            		    		if (fShowFavorite) {
            			    		var favoriteConfig={
            			    			'0': {screen:15,button:15,name:'',type:0},
            			    			'1': {screen:15,button:15,name:'',type:0},
            			    			'2': {screen:15,button:15,name:'',type:0},
            			    			'3': {screen:15,button:15,name:'',type:0},
            			    			'4': {screen:15,button:15,name:'',type:0},
            			    			'5': {screen:15,button:15,name:'',type:0},
            			    			'6': {screen:15,button:15,name:'',type:0}
            			    		};
            			    		if (result.result[sKey].favorite!=null){
            			    			for (var oKey in result.result[sKey].favorite) {
            			    				var oFavObject={
            			    					screen:result.result[sKey].favorite[oKey].screen,
            			    					button:result.result[sKey].favorite[oKey].button,
            			    					name:dss.unescapeProperty(result.result[sKey].favorite[oKey].name),
            			    					type:0
            			    				};    
            			    				if (result.result[sKey].favorite[oKey].screen!=15)
            			    					oFavObject.type=screenTypeMapping[''+result.result[sKey].favorite[oKey].screen];
            			    				favoriteConfig[oKey]=oFavObject;
            			    			}
            			    		}
            			    		var oObject={
            			    				dSID:'-1',
            			    				grouping: oDeviceObject.name + ' ('  +  baseDSID.substr(24,8) + ')',
            			    				basedSID:baseDSID,
            			    				type:-1,
            			    				zoneID:0,
            			    				buttontype:-1,
            			    				order:0,
            			    				buttonTypeConfig:{
            			    				},
            			    				sceneNames:{
            			    				},
            			    				keepInSync:true,
            			    				favoriteConfig:favoriteConfig
            			    			};
            			    		oArray.push(oObject);    			
            		    		}
            		    	}
            			}

            	    	grid.loadParameter(oArray);
            			grid.btnCustom[0].setDisabled(!me.fSomethingAvaible);
            			grid.btnCustom[1].setDisabled(!me.fSomethingAvaible);
            			//grid.btnCustom[3].setDisabled(!fSomethingAvaible);
            			grid.btnCustomRAlign[0].setDisabled(true);
            			grid.btnCustomRAlign[1].setDisabled(true);

            			if (me.preserveSelection!=null) {
            	    		var oRecord=grid.store.findRecord('dSID',me.preserveSelection,0,true,false,true);
            	    		if (oRecord!=null)
            	    			grid.getSelectionModel().select(oRecord);
            	    		else
            	    			me.preserveSelection=null;
            	    	}
            	    	
            			if (fWizardShouldBeHinted) {
            				if (nervDisplay)
            					me.startWizard();
            				nervDisplay=false;
            			}
            			if (oArray.length==0)
            				me.showEmptyNotice();
            	    	//grid.setStatus(_('<table><tr><td style="margin-top: 4px; padding-right: 6px; padding-top: 5px;"><img src="/framework/images/groupIcons/group_7.png"></td><td style="padding-top:5px;">Ready</td></tr></table>'));
            			
            			
        			});
    				
    			});
    			
    	       	
    			
    		}
    	);
    	
    },
    fSomethingAvaible:false,
    waitAndReload : function(grid,parameter) {
    	dss.raiseEvent('thanos.config',parameter);
    	this.progress.setVisible(true);
    	this.progress.maximunStep=0;
		this.fShouldWork=true;
		grid.setStatus(_('Preparing data'));
    }, 
    checkAndUpdate: function() {    	    	
    	var me=this;
    	dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
    	    subscriptionID : this.iSubscript,
    	    timeout : 5 * 1000
    	}, function(answer) {	
    		try {
                var result = Ext.JSON.decode(answer);
        		if (result.ok==false) {
        			this.startQueue();
    				return;
                }
        		if (result.result != null) {
        			if (result.result.events!=null)
            			if (result.result.events.length>0) {
            				me.fShouldWork=false;
            				var messages=[];
            				for (var iIndex=0;iIndex<result.result.events.length;iIndex ++) {
            					if (result.result.events[iIndex].properties.errorCode!=null) {
            						switch (result.result.events[iIndex].properties.errorCode) {
            						case "1":
            							messages.push(Ext.String.format2(_("Only 8 screens can be added"),{name:dss.staticDataModel.getDevice(result.result.events[iIndex].properties.baseDSID).name}));
            						break;
            						}
            					}
            				}
            				if (messages.length>0)
            					Ext.MessageBox.alert(_('Error'), messages.join('\n'), null);
            				me.loadParameter(me.grid);
            			}            				
        		}	
    		} catch (e) {}
    		me.checkAndUpdate();            
    	});
    },
    check: function() {
    	var me=this;
    	dss.ajaxAssyncRequestWithoutAnswer('/json/property/query2', {
			'query' : '/scripts/thanos/queue/*(state)/data/*(type,state,subIndex,length,dsid,meta)'
		} , function(sString) {
			
			result = Ext.JSON.decode(sString);
			var iWorkingOn=0;
			var aDsidsOnWork=[];
			for (var sKey in result.result) {
				if (result.result[sKey].state!='end')
					if (result.result[sKey].state!='error') {
						for (var kKey in result.result[sKey]) {
							if (kKey!='state') {
								var oQueueItem=result.result[sKey][kKey];
								if (oQueueItem.state!='finish') {
									if (oQueueItem.meta!=null) {
										var oTargetDSID=oQueueItem.dsid;
										if (oQueueItem.meta=='favorite') {
											oTargetDSID=oQueueItem.dsid+'_favorite';									
											if (aDsidsOnWork.indexOf(oTargetDSID)<0) {
												aDsidsOnWork.push(oTargetDSID);
											}									
										} else if (oQueueItem.meta=='general') {
											
											var baseIndex=Math.floor(parseInt(oQueueItem.dsid.substring(oQueueItem.dsid.length-3).substring(0,1),16)/8)*8;
											var parentDSID=oQueueItem.dsid.substring(0,oQueueItem.dsid.length-3);
											for (var iIndex=0;iIndex<8;iIndex++) {
												var oTargetDSID=parentDSID + '' + (baseIndex+iIndex).toString(16) + "00";
												if (aDsidsOnWork.indexOf(oTargetDSID)<0) {
													aDsidsOnWork.push(oTargetDSID);
												}									
											}
										}
									} else
										if (aDsidsOnWork.indexOf(oQueueItem.dsid)<0)
											aDsidsOnWork.push(oQueueItem.dsid);
									if (oQueueItem.type=='readDataBlock') {
										iWorkingOn+=parseInt("" + oQueueItem.length,10);
										if (oQueueItem.subIndex!=null)
											iWorkingOn-=parseInt("" + oQueueItem.subIndex,10);
									}
									else if (oQueueItem.type=='writeTextBlock') {
										iWorkingOn+=parseInt("" + oQueueItem.length,10) 
										if (oQueueItem.subIndex!=null)
											iWorkingOn-=parseInt("" + oQueueItem.subIndex,10);
									}
									else
										iWorkingOn+=1;								
								}
							}
								
						}
					}
						
			}
			
			for (var iIndex=0;iIndex<me.grid.store.count();iIndex++) {
				var dsid=me.grid.store.getAt(iIndex).get('dSID');
				if (dsid=='-1') 
					dsid=me.grid.store.getAt(iIndex).get('basedSID') + '_favorite';
	
				if (aDsidsOnWork.indexOf(dsid)<0) {
					if (document.getElementById('dsid_'+dsid+'_working')!=null)
						document.getElementById('dsid_'+dsid+'_working').style="width:0px";
					if (document.getElementById('dsid_'+dsid+'_ready')!=null)
						document.getElementById('dsid_'+dsid+'_ready').style="width:16px";
				} else {
					if (document.getElementById('dsid_'+dsid+'_working')!=null)
						document.getElementById('dsid_'+dsid+'_working').style="width:16px";	
					if (document.getElementById('dsid_'+dsid+'_ready')!=null)
						document.getElementById('dsid_'+dsid+'_ready').style="width:0px";
				}
			}
			if (iWorkingOn>0) {
				if (me.progress.maximunStep==0) {
					me.progress.maximunStep=iWorkingOn;
				}
				if (me.progress.maximunStep<iWorkingOn){
					me.progress.maximunStep=iWorkingOn;
				}
				me.progress.updateProgress((me.progress.maximunStep-iWorkingOn)/me.progress.maximunStep,'',true);
				
				me.fShouldWork=false;
		    	me.progress.setVisible(true);
		    	if (expertMode)
		    		me.grid.setStatus(_('writing Data' +' ' + iWorkingOn  + '/' + me.progress.maximunStep));
		    	else
		    		me.grid.setStatus(_('writing Data'));
			} else {
				if (me.fShouldWork==false) { 
					me.progress.maximunStep=0;
					me.progress.updateProgress(0);
			    	me.progress.setVisible(false);
			    	me.grid.setStatus(_('Ready'));
				}
			}
		});
	},
    startQueue: function() {
    	this.iSubscript = Math.floor(Math.random() * 100000000000);
    	dss.ajaxSyncRequest('/json/event/subscribe', {
    	    subscriptionID : this.iSubscript,
    	    name : 'thanos.saved'
    	});
    	this.checkAndUpdate();
    }
});

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/thanos.po']);
    var EmailEdit = Ext.create('DSS.addon.Thanos');
    EmailEdit.initPage();
});


function globalCheck() {	
	if (baseDialog!=null) {
		baseDialog.check();
	}
    window.setTimeout("globalCheck();",5*1000);
}